Reforgerade = LibStub("AceAddon-3.0"):NewAddon("Reforgerade", "AceConsole-3.0", "AceTimer-3.0")
local AceGUI = LibStub("AceGUI-3.0")
local Reforgerade = Reforgerade
local reforgeString
local reforgeTable = {}
local RfInfo = LibStub("LibReforgingInfo-1.0")

local debugPrint = false
local debugErrors = true

local firstRun = true

reforgeradeOptionsTable = {
  type = "group",
  args = {
    debugEnable = {
      name = "Debug",
      desc = "Enables / disables debugging",
      type = "toggle",
      set = function(info,val) debugPrint = val end,
      get = function(info) return debugPrint end
    },
    debugErrors = {
      name = "Display Errors",
      desc = "Enables / disables displaying error messages",
      type = "toggle",
      set = function(info,val) debugErrors = val end,
      get = function(info) return debugErrors end
    },
  }
}
LibStub("AceConfig-3.0"):RegisterOptionsTable("Reforgerade", reforgeradeOptionsTable)
local optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Reforgerade")

Reforgerade:RegisterChatCommand("rfa", "ChatCommand")
Reforgerade:RegisterChatCommand("reforgerade", "ChatCommand")

function Reforgerade:ChatCommand(parameter)
	if not parameter or parameter:trim() == "" then
		ReforgeradeInputFrame.frame:Show()
	else
		parameter = parameter:trim():lower()
		if parameter == "options" or parameter == "config" then
			 InterfaceOptionsFrame_OpenToCategory(optionsFrame)
		end
	end	
end


--Stole from LibReforge
local SPI = 1
local DODGE = 2
local PARRY = 3
local HIT = 4
local CRIT = 5
local HASTE = 6
local EXP = 7
local MASTERY = 8

--Stole from LibReforge
local StatNames = {
	ITEM_MOD_SPIRIT_SHORT,
	ITEM_MOD_DODGE_RATING_SHORT,
	ITEM_MOD_PARRY_RATING_SHORT,
	ITEM_MOD_HIT_RATING_SHORT,
	ITEM_MOD_CRIT_RATING_SHORT,
	ITEM_MOD_HASTE_RATING_SHORT,
	ITEM_MOD_EXPERTISE_RATING_SHORT,
	ITEM_MOD_MASTERY_RATING_SHORT
}
StatNames[0] = "None"
local StatToString = {
	"ITEM_MOD_SPIRIT_SHORT",
	"ITEM_MOD_DODGE_RATING_SHORT",
	"ITEM_MOD_PARRY_RATING_SHORT",
	"ITEM_MOD_HIT_RATING_SHORT",
	"ITEM_MOD_CRIT_RATING_SHORT",
	"ITEM_MOD_HASTE_RATING_SHORT",
	"ITEM_MOD_EXPERTISE_RATING_SHORT",
	"ITEM_MOD_MASTERY_RATING_SHORT"
}


local reforgequeue = {}
local reforgeParsers = {}

local specialItems = {}
specialItems[select(1,GetItemInfo(69834)) or "Cloudburst Cloak"] = true
specialItems[select(1,GetItemInfo(69829)) or "Cloudburst Necklace"] = true
specialItems[select(1,GetItemInfo(63499)) or "Cloudburst Ring"] = true
specialItems[select(1,GetItemInfo(63497)) or "Gale Rouser Belt"] = true
specialItems[select(1,GetItemInfo(63506)) or "Gale Rouser Leggings"] = true
specialItems[select(1,GetItemInfo(63496)) or "Lightning Well Belt"] = true
specialItems[select(1,GetItemInfo(63505)) or "Lightning Well Legguards"] = true
specialItems[select(1,GetItemInfo(63488)) or "Mistral Circle"] = true
specialItems[select(1,GetItemInfo(63489)) or "Permafrost Signet"] = true
specialItems[select(1,GetItemInfo(69830)) or "Planetary Amulet"] = true
specialItems[select(1,GetItemInfo(63494)) or "Planetary Band"] = true
specialItems[select(1,GetItemInfo(69835)) or "Planetary Drape"] = true
specialItems[select(1,GetItemInfo(63490)) or "Sky Strider Belt"] = true
specialItems[select(1,GetItemInfo(63500)) or "Sky Strider Greaves"] = true
specialItems[select(1,GetItemInfo(63498)) or "Soul Breath Belt"] = true
specialItems[select(1,GetItemInfo(63507)) or "Soul Breath Leggings"] = true
specialItems[select(1,GetItemInfo(63492)) or "Star Chaser Belt"] = true
specialItems[select(1,GetItemInfo(63502)) or "Star Chaser Legguards"] = true
specialItems[select(1,GetItemInfo(68127)) or "Stormwake, the Tempest's Reach"] = true
specialItems[select(1,GetItemInfo(63495)) or "Tempest Keeper Belt"] = true
specialItems[select(1,GetItemInfo(63504)) or "Tempest Keeper Leggings"] = true
specialItems[select(1,GetItemInfo(63491)) or "Thunder Wall Belt"] = true
specialItems[select(1,GetItemInfo(63501)) or "Thunder Wall Greaves"] = true
specialItems[select(1,GetItemInfo(63493)) or "Wind Stalker Belt"] = true
specialItems[select(1,GetItemInfo(63503)) or "Wind Stalker Leggings"] = true

function Reforgerade:DebugPrint(debugString)
	if (debugPrint) then
		self:Print("DEBUG: " .. debugString)
	end
end

function Reforgerade:ErrorPrint(errorString)
	if (debugErrors) then
		self:Print("|cffff0000 ERROR: " .. errorString .. "|r")
	end
end

function Reforgerade:IsValidReforge(item, from, to, silent)
	self:DebugPrint("Checking "  .. item .. " " .. from .. " -> " .. to .. " for validity")
	silent = silent or false --default to false if called with nil
	if not item or not from or not to then return false end
--~ 	if (specialItems[Reforgerade:FixItemName(item)] ~= nil) then
--~ 		return true
--~ 	end
	if (GetItemInfo(item)) then
		if (from <= 8 and to <= 8) then
			local statTable = {}
			if (specialItems[Reforgerade:FixItemName(item)] ~= nil) then
				self:DebugPrint("getting special item stats")
				statTable = Reforgerade:GetStatsFromSuffix(item)
				if next(statTable) == nil then return true end --If we cant get the stats for the item from the suffix skip the check
			else
				GetItemStats(select(2, GetItemInfo(item)), statTable)
			end
			if ((statTable[StatToString[from]] ~= nil and statTable[StatToString[from]] > 0) or from == 0) then
				if (statTable[StatToString[to]] == nil) then
--~ 					print("item is valid")
					return true
				else
					if (not silent) then
						self:DebugPrint(item .. " already has " .. StatNames[to] .. ". " .. StatNames[from] .. " -> " .. StatNames[to] .. " is an invalid reforge option.")
					end
					return false, item .. " already has " .. StatNames[to] .. ". " .. StatNames[from] .. " -> " .. StatNames[to] .. " is an invalid reforge option."
				end
			else
				if (not silent) then
					self:DebugPrint(item .. " does not have " .. StatNames[from] .. ". " .. StatNames[from] .. " -> " .. StatNames[to] .. " is an invalid reforge option.")
				end
				return false, item .. " does not have " .. StatNames[from] .. ". " .. StatNames[from] .. " -> " .. StatNames[to] .. " is an invalid reforge option."
			end
		else
			if (not silent) then
				self:DebugPrint("Invalid reforge IDs for " .. item)
			end
			return false
		end
	else
		if (specialItems[Reforgerade:FixItemName(item)] ~= nil) then
			return true
		end
		if (not silent) then
			self:DebugPrint(item .. " appears to be an invalid item.")
		end
		return false, item .. " appears to be an invalid item name."
	end
end

function Reforgerade:BuildReforgeTable(silent)
	silent = silent or false --default to false if called with nil
	local reforgeString = ReforgeradeInputFrame.editBox:GetText()
	reforgeTable = {}
	local parseAttempts = {}
	local best = 0
	local parserName = nil
	local pickedParser = nil
	if next(reforgeParsers) ~= nil then
		for parserName, parserFunction in pairs(reforgeParsers) do --for each parser added to our list let them try parsing the data
			parseAttempt = parserFunction(reforgeString)
			local validItems = 0
			local attemptedReforges = 0
			if (parseAttempt and next(parseAttempt) ~= nil) then
				for itemName,reforgeID in pairs(parseAttempt) do
					if (Reforgerade:IsValidReforge(itemName, reforgeID[1], reforgeID[2], silent)) then
						validItems = validItems + 1					
					end
					attemptedReforges = attemptedReforges + 1
				end
			end
			if (not silent) then
				self:DebugPrint(parserName .. " returned " .. validItems .. " valid item reforges")
			end
			if ((validItems > best) or (best == 0 and attemptedReforges > 0)) then
				best = validItems
				reforgeTable = parseAttempt
				pickedParser = parserName
			end
		end
		
		if next(reforgeTable) ~= nil then
			if (not silent) then
				self:DebugPrint("Picked parser: " .. pickedParser)
			end
			local finalizedTable = {}
			for itemName,reforgeID in pairs(reforgeTable) do
				local valid, reason = Reforgerade:IsValidReforge(itemName, reforgeID[1], reforgeID[2], silent)
				if (valid) then
					finalizedTable[itemName] = {reforgeID[1], reforgeID[2]}
				else
					if (firstRun) then
						if (reason) then
							self:ErrorPrint(reason)
						else
							self:ErrorPrint("Removing invalid reforge request for " .. itemName)
						end
					end
				end
			end
			reforgeTable = finalizedTable
		else
			self:ErrorPrint("Unable to parse input")
		end
--~ 		for k,v in pairs(reforgeTable) do
--~ 			print("Finalized Reforge " .. k .. " from " .. v[1] .. " to " .. v[2])
--~ 		end
	else
		self:ErrorPrint("No reforge parsers found!")
	end
end

function Reforgerade:ReforgeScan(silent)
	
	silent = silent or false --default to false if called with nil
--~ 	if ReforgeradeInputFrame.frame:IsShown() == false then ReforgeradeInputFrame.frame:Show() return end
	Reforgerade:BuildReforgeTable(silent) --rebuild the list of want reforges
	reforgequeue = {} --clear the reforge queue
	local itemChanged = false
	for i = 1, 18 do
--~ 	for i = 1, 2 do
		local item = GetInventoryItemLink("player", i)
		if (item and i~=4) then --if we have and item equiped in the slot and the slot is not the shirt or tabard slot
			local itemName = select(1,GetItemInfo(item))
			if (reforgeTable[itemName] == nil) then
				itemName = Reforgerade:FixItemName(itemName)
			end
	--~ 		self:DebugPrint(itemName .. "|")
			local WantReforgeFrom, WantReforgeTo
			if (reforgeTable[itemName] ~= nil) then
				WantReforgeFrom = reforgeTable[itemName][1]
				WantReforgeTo = reforgeTable[itemName][2]
				local CurrentReforgeFrom, CurrentReforgeTo
				if RfInfo:IsItemReforged(item) then
					CurrentReforgeFrom, CurrentReforgeTo = RfInfo:GetReforgedStatIDs(RfInfo:GetReforgeID(item))			
				end
				if (CurrentReforgeFrom == nil or CurrentReforgeTo == nil) then
					CurrentReforgeFrom = 0
					CurrentReforgeTo = 0
				end
		--~ 			self:Print(itemName .. " is reforged from " .. CurrentReforgeFrom .. " to " .. CurrentReforgeTo)
				if (CurrentReforgeFrom ~= WantReforgeFrom or CurrentReforgeTo ~= WantReforgeTo) then
					if (not silent) then
						self:Print(item .. " currently reforged from " .. StatNames[CurrentReforgeFrom] .. " -> " .. StatNames[CurrentReforgeTo] .. " needs to be reforged from " .. StatNames[WantReforgeFrom] .. " -> " .. StatNames[WantReforgeTo])
						itemChanged = true
					end
					tinsert(reforgequeue, {i, WantReforgeFrom, WantReforgeTo})
				else
					if (not silent) then
--~ 	 					self:Print("No need to change reforging for " ..item)
					end
				end
			else
				if (not silent) then
	 				self:DebugPrint("Unable to find wanted reforge information for equiped item " .. item)
				end
			end
		end
	end
	if (not silent) then
		if (itemChanged == false) then
			self:Print("Everything is already reforged.")
		end
	end
end

local currentSlot = 0

function Reforgerade:ReforgeIt()
	Reforgerade:ReforgeScan(true)
--~ 	self:DebugPrint("Running ReforgingIt")
	if (#reforgequeue == 0 or reforgequeue == {} or reforgequeue == nil) then
		self:Print("Reforging Complete")
		firstRun = true
		if (ReforgingFrameItemButton and ReforgingFrameItemButton:IsVisible()) then
			ClearCursor()
			ReforgingFrameItemButton:Click() -- pick up the old item
			ClearCursor() --get rid of it
		end
		currentSlot = 0
		return
	end
	if (ReforgingFrame == nil  or ReforgingFrame:IsVisible() == nil) then
		self:ErrorPrint("Open the reforging frame")
		return
	end
	firstRun = false
	self:DebugPrint(#reforgequeue .. " items need to be reforged")
	for k, v in pairs(reforgequeue) do
--~ 		self:Print(v[1])
		--Pick up the item and place it in the reforge windo
		local itemSlot = v[1]
		local item = GetInventoryItemLink("player", itemSlot)
		if (currentSlot ~= itemSlot) then
			ClearCursor()
			ReforgingFrameItemButton:Click() -- pick up the old item
			ClearCursor() --get rid of it
			PickupInventoryItem(itemSlot)
			ReforgingFrameItemButton:Click()
			currentSlot = itemSlot
--~ 			self:DebugPrint("Placing " .. item .. " in the reforge window.")
		end
		local reforgeID
		if v[2] == 0 then
			reforgeID = 0
		else
			local stats = {GetSourceReforgeStats()};
			local fromStats = #stats/3
	--~ 		print("number of stats to reforge from " .. fromStats)
			local combinations = (8-fromStats)*fromStats
	--~ 		print("total reforge combinations " .. combinations)
			for i=1, combinations do
				from, _, _, to, _, _ = GetReforgeOptionInfo(i)
	--~ 			print(from .. " -> " .. to)
				if (StatNames[v[2]] == from and StatNames[v[3]] == to) then
					reforgeID = i
					break
				end
			end
		end
--~ 		self:DebugPrint("Found reforge combination reforge ID is " .. reforgeID)
		if reforgeID then
			self:DebugPrint("Reforging " .. item)
			ReforgeItem(reforgeID)
			Reforgerade:RetryReforge()
			return
		else
			self:ERRORPrint("Unable to find wanted reforge option for item " .. item)
		end
	end
	Reforgerade:RetryReforge()
end

function Reforgerade:RetryReforge()
	local waitTime = max(select(4, GetNetStats())*2, 250) -- Wait for 2x current latentcy or 250ms whichever is larger and do it again
--~ 	self:DebugPrint("Next action in " .. waitTime .. "ms")
	self:ScheduleTimer("ReforgeIt", waitTime/1000)  
end


--removes of the Stormblast from item names so they can be compared to the reforge list
function Reforgerade:FixItemName(itemName)
	itemName = string.gsub(itemName, " of the Stormblast", "")
	itemName = string.gsub(itemName, " of the Windflurry", "")
	itemName = string.gsub(itemName, " of the Windstorm", "")
	itemName = string.gsub(itemName, " of the Zephyr", "")
	return itemName
end

--Takes an item name or suffix
function Reforgerade:GetStatsFromSuffix(item)
self:DebugPrint("Getting stats for " .. item)
--~ 	"ITEM_MOD_SPIRIT_SHORT",
--~ 	"ITEM_MOD_DODGE_RATING_SHORT",
--~ 	"ITEM_MOD_PARRY_RATING_SHORT",
--~ 	"ITEM_MOD_HIT_RATING_SHORT",
--~ 	"ITEM_MOD_CRIT_RATING_SHORT",
--~ 	"ITEM_MOD_HASTE_RATING_SHORT",
--~ 	"ITEM_MOD_EXPERTISE_RATING_SHORT",
--~ 	"ITEM_MOD_MASTERY_RATING_SHORT"
	if item:find("Stormblast") then
		return {["ITEM_MOD_HIT_RATING_SHORT"] =1, ["ITEM_MOD_CRIT_RATING_SHORT"] = 1} 
	end
	if item:find("Windflurry") then
		return {["ITEM_MOD_CRIT_RATING_SHORT"] =1, ["ITEM_MOD_HASTE_RATING_SHORT"] = 1} 
	end
	if item:find("Windstorm") then 
		return {["ITEM_MOD_CRIT_RATING_SHORT"] =1, ["ITEM_MOD_MASTERY_RATING_SHORT"] = 1} 
	end
	if item:find("Zephyr") then 
		return {["ITEM_MOD_HASTE_RATING_SHORT"] =1, ["ITEM_MOD_MASTERY_RATING_SHORT"] = 1} 
	end
	return
end

function Reforgerade:RegisterParser(name, func)
	self:DebugPrint("Registering parser " .. name)
	reforgeParsers[name] = func
end

--Stolen from shadowcraft-tools
ReforgeradeInputFrame = {}
ReforgeradeInputFrame.frame = nil
ReforgeradeInputFrame.frame = CreateFrame("Frame", "ReforgeradeInputFrame", UIParent)
ReforgeradeInputFrame.frame:SetBackdrop({
		bgFile = "Interface\\Addons\\Reforgerade\\media\\textures\\blank", --zomg stolen textures too
		edgeFile = "Interface\\Addons\\Reforgerade\\media\\textures\\blank",
		tile = true, tileSize = 16, edgeSize = 1, 
		insets = { left = -1, right = -1, top = -1, bottom = -1 }
})
ReforgeradeInputFrame.frame:SetBackdropColor(0.1,0.1,0.1,1)
ReforgeradeInputFrame.frame:SetBackdropBorderColor(0.6, 0.6, 0.6, 0.5)
ReforgeradeInputFrame.titleString = ReforgeradeInputFrame.frame:CreateFontString("TitleString");
ReforgeradeInputFrame.titleString:SetFont("Interface\\Addons\\Reforgerade\\media\\fonts\\arial.ttf",12)  --eek stolen fonts
ReforgeradeInputFrame.titleString:SetPoint("TOP", ReforgeradeInputFrame.frame, "TOP", -2, -2)
ReforgeradeInputFrame.titleString:SetText("Reforgerade")

ReforgeradeInputFrame.frame:SetWidth(400)
ReforgeradeInputFrame.frame:SetHeight(400)
ReforgeradeInputFrame.frame:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
ReforgeradeInputFrame.frame:Hide()
ReforgeradeInputFrame.frame:SetFrameStrata("DIALOG")

local scrollArea = CreateFrame("ScrollFrame", "ExportScroll", ReforgeradeInputFrame.frame, "UIPanelScrollFrameTemplate")
scrollArea:SetPoint("TOPLEFT", ReforgeradeInputFrame.frame, "TOPLEFT",8, -30)
scrollArea:SetPoint("BOTTOMRIGHT", ReforgeradeInputFrame.frame, "BOTTOMRIGHT", -30, 8)

ReforgeradeInputFrame.editBox = CreateFrame("EditBox", "ExportBox", ReforgeradeInputFrame.frame)
ReforgeradeInputFrame.editBox:SetMultiLine(true)
ReforgeradeInputFrame.editBox:SetMaxLetters(99999)
ReforgeradeInputFrame.editBox:EnableMouse(true)
ReforgeradeInputFrame.editBox:SetAutoFocus(true)
ReforgeradeInputFrame.editBox:SetFontObject(ChatFontNormal)
ReforgeradeInputFrame.editBox:SetWidth(362)
ReforgeradeInputFrame.editBox:SetHeight(400)
ReforgeradeInputFrame.editBox:SetScript("OnEscapePressed", function() ReforgeradeInputFrame.frame:Hide() end)

scrollArea:SetScrollChild(ReforgeradeInputFrame.editBox)

local close = CreateFrame("Button", "CopyCloseButton", ReforgeradeInputFrame.frame, "UIPanelCloseButton")
close:SetPoint("TOPRIGHT", ReforgeradeInputFrame.frame, "TOPRIGHT")

local ReforgeCompareButton = CreateFrame("Button", "ReforgeCompareButton", ReforgeradeInputFrame.frame, "OptionsButtonTemplate")
ReforgeCompareButton:SetPoint("BOTTOMRIGHT", ReforgeradeInputFrame.frame, "BOTTOM")
ReforgeCompareButton:SetText("Compare")
ReforgeCompareButton:SetScript("OnClick", function() Reforgerade:ReforgeScan(false) end)

local ReforgeItButton = CreateFrame("Button", "ReforgeItButton", ReforgeradeInputFrame.frame, "OptionsButtonTemplate")
ReforgeItButton:SetPoint("BOTTOMLEFT", ReforgeradeInputFrame.frame, "BOTTOM")
ReforgeItButton:SetText("Reforge It")
ReforgeItButton:SetScript("OnClick", function() firstRun = true currentSlot = 0 Reforgerade:ReforgeIt() end)